# SPDX-License-Identifier: GPL-2.0
%YAML 1.2
---
$id: http://devicetree.org/schemas/bus/allwinner,sun50i-a64-de2.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Allwinner A64 Display Engine Bus Device Tree Bindings

maintainers:
  - Chen-Yu Tsai <wens@csie.org>
  - Maxime Ripard <mripard@kernel.org>

properties:
  $nodename:
    pattern: "^bus(@[0-9a-f]+)?$"

  "#address-cells":
    const: 1

  "#size-cells":
    const: 1

  compatible:
    oneOf:
      - const: allwinner,sun50i-a64-de2
      - items:
          - const: allwinner,sun50i-h6-de3
          - const: allwinner,sun50i-a64-de2

  reg:
    maxItems: 1

  allwinner,sram:
    description:
      The SRAM that needs to be claimed to access the display engine
      bus.
    $ref: /schemas/types.yaml#definitions/phandle-array
    maxItems: 1

  ranges: true

patternProperties:
  # All other properties should be child nodes with unit-address and 'reg'
  "^[a-zA-Z][a-zA-Z0-9,+\\-._]{0,63}@[0-9a-fA-F]+$":
    type: object
    properties:
      reg:
        maxItems: 1

    required:
      - reg

required:
  - compatible
  - reg
  - "#address-cells"
  - "#size-cells"
  - ranges
  - allwinner,sram

additionalProperties: false

examples:
  - |
    bus@1000000 {
        compatible = "allwinner,sun50i-a64-de2";
        reg = <0x1000000 0x400000>;
        allwinner,sram = <&de2_sram 1>;
        #address-cells = <1>;
        #size-cells = <1>;
        ranges = <0 0x1000000 0x400000>;

        display_clocks: clock@0 {
            compatible = "allwinner,sun50i-a64-de2-clk";
            reg = <0x0 0x100000>;
            clocks = <&ccu 52>, <&ccu 99>;
            clock-names = "bus", "mod";
            resets = <&ccu 30>;
            #clock-cells = <1>;
            #reset-cells = <1>;
        };
    };

...
